import * as cc from 'cc'
import 'tools-javascript'
import { I18n, Res, Sound } from 'tools-cocos3x'

const { ccclass } = cc._decorator

@ccclass
export default class Main extends cc.Component {
    async onLoad() {
        const _this = this

        CEvent.emit('toggleGameDiv', true)

        Sound.init()

        const langObj = {
            zh: {
                title: '标题',
                loading: '加载中',
                qq: '作者在群里'
            },
            en: {
                title: 'Title',
                loading: 'Loading',
                qq: '群号:521643513'
            }
        } as any
        I18n.getLangJson = async (lang: string) => {
            return langObj[lang]
        }
        I18n.init({
            lang: 'zh',
            langList: ['zh'],
            defaultLang: 'en'
        })

        await Res.loadBundle('home', {
            onProgress(param) {
                // console.log(param)
            }
        })

        const _lang = await Res.getAsset<cc.Prefab>('prefab/lang', cc.Prefab)
        const _node = cc.instantiate(_lang)
        _this.node.addChild(_node)

        _this.node.on(cc.Node.EventType.TOUCH_START, async () => {
            await _this.setLang('zh')
        })

        _this.node.on(cc.Node.EventType.TOUCH_END, async () => {
            await _this.setLang('en')
        })

        const _sound = await Sound.play('Bonus_start', { autoPlay: false })
        _sound.play()
    }

    setLangPro: Promise<any> = null!
    async setLang(lang: string) {
        if (this.setLangPro) await this.setLangPro
        this.setLangPro = new Promise(async (resolve, reject) => {
            await Res.loadBundle('home', { lang })
            I18n.setLang(lang)
            resolve((this.setLangPro = null!))
        })
    }

    start() {}
}
