import * as cc from 'cc'
import { SpriteInfoBase } from 'tools-cocos3x'
const { ccclass, property, executeInEditMode } = cc._decorator

/**
 * 节点使用配置，对图片和骨骼进行多语言处理
 */
@ccclass('SpriteInfo')
@executeInEditMode
export default class SpriteInfo extends SpriteInfoBase {

    @property({ tooltip: '资源名称', readonly: true })
    urlName: string = ''
    
    @property({ tooltip: '骨骼动画默认播放动画名称' })
    aniName: string = ''

    @property({ tooltip: '骨骼动画是否循环播放' })
    aniLoop: boolean = true

    @property({ tooltip: '项目地址', readonly: true, visible: false })
    url: string = ''

    @property({ tooltip: '资源uuid', readonly: true, visible: false })
    urlUUID: string = ''

    @property({ tooltip: '资源类型', readonly: true, visible: false })
    type: string = ''

}
