"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.onAfterMake = exports.onBeforeMake = exports.onError = exports.unload = exports.onAfterBuild = exports.onAfterCompressSettings = exports.onBeforeCompressSettings = exports.onBeforeBuild = exports.load = exports.throwError = void 0;
const path_1 = __importDefault(require("path"));
const global_1 = require("./global");
const EFileUtil_1 = __importDefault(require("./EFileUtil"));
const EHttpUtil_1 = __importDefault(require("./EHttpUtil"));
const fs = __importStar(require("fs"));
const util = {
    file: EFileUtil_1.default,
    http: EHttpUtil_1.default,
};
exports.throwError = true;
const load = function () {
    return __awaiter(this, void 0, void 0, function* () {
        console.log(global_1.PACKAGE_NAME, 'BuildHook.load');
    });
};
exports.load = load;
//插件目录
let configjs = {};
const onBeforeBuild = function (options, result) {
    return __awaiter(this, void 0, void 0, function* () {
        configjs = {};
        console.log('onBeforeBuild', options, result, configjs);
        const dest = result.dest;
        const projectDir = dest.substring(0, dest.lastIndexOf('\\build\\'));
        const _configjs = path_1.default.join(projectDir, 'cocos-template.js');
        if (fs.existsSync(_configjs)) {
            delete require.cache[require.resolve(_configjs)];
            configjs = require(_configjs);
        }
        if (configjs.onBeforeBuild) {
            try {
                yield configjs.onBeforeBuild(options, result, util);
            }
            catch (error) {
                console.error(error);
            }
        }
    });
};
exports.onBeforeBuild = onBeforeBuild;
const onBeforeCompressSettings = function (options, result) {
    return __awaiter(this, void 0, void 0, function* () { });
};
exports.onBeforeCompressSettings = onBeforeCompressSettings;
const onAfterCompressSettings = function (options, result) {
    return __awaiter(this, void 0, void 0, function* () { });
};
exports.onAfterCompressSettings = onAfterCompressSettings;
const getDirFiles = (dir) => {
    return new Promise((res) => __awaiter(void 0, void 0, void 0, function* () {
        let arr = [];
        yield EFileUtil_1.default.readDirectory(dir, (filepath) => {
            arr.push(filepath);
        });
        res(arr);
    }));
};
const onAfterBuild = function (options, result) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log('onAfterBuild', options, result, configjs);
        const dest = result.dest;
        //------将静态资源目录打包进项目
        const projectDir = dest.substring(0, dest.lastIndexOf('\\build\\'));
        const path1 = path_1.default.join(projectDir, 'public');
        const path2 = path_1.default.join(dest, 'cocosjs');
        EFileUtil_1.default.copyFolder(path1, path2);
        //------结束
        //------处理index.html中的所有预留插槽
        const tphtmldir = path_1.default.join(projectDir, 'build-templates/' + options.platform);
        let files = (yield getDirFiles(tphtmldir));
        files = files.filter((item) => !item.endsWith('index.html') && item.endsWith('.html'));
        let filesMap = {};
        for (let i = 0; i < files.length; i++) {
            const item = files[i];
            const _name = item.replace(tphtmldir, '').replace('\\', '').replace('.html', '');
            const _fc = yield EFileUtil_1.default.readFile(item);
            filesMap[_name] = {
                url: item,
                file: _fc
            };
        }
        const _indexhtmlpath = path_1.default.join(dest, 'index.html');
        if (fs.existsSync(_indexhtmlpath)) {
            let htmlcontent = yield EFileUtil_1.default.readFile(_indexhtmlpath);
            Object.keys(filesMap).forEach((key) => {
                const _item = filesMap[key];
                htmlcontent = htmlcontent.replace(`<!--#${key}-->`, _item.file);
            });
            yield EFileUtil_1.default.writeFile(_indexhtmlpath, htmlcontent);
        }
        if (configjs.onAfterBuild) {
            try {
                yield configjs.onAfterBuild(options, result, util);
            }
            catch (error) {
                console.error(error);
            }
        }
    });
};
exports.onAfterBuild = onAfterBuild;
const unload = function () {
    return __awaiter(this, void 0, void 0, function* () {
        console.log('unload');
    });
};
exports.unload = unload;
const onError = function (options, result) {
    return __awaiter(this, void 0, void 0, function* () { });
};
exports.onError = onError;
const onBeforeMake = function (root, options) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log({
            root,
            options
        }, 'onBeforeMake');
    });
};
exports.onBeforeMake = onBeforeMake;
const onAfterMake = function (root, options) {
    return __awaiter(this, void 0, void 0, function* () {
        console.log({
            root,
            options
        }, 'onAfterMake');
    });
};
exports.onAfterMake = onAfterMake;
