// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../lib/cc.d.ts

declare module 'tools-cocos3x' {
    export { CKeyUtil } from 'tools-cocos3x/CKeyUtil';
    export { Res } from 'tools-cocos3x/Res';
    export { Sound } from 'tools-cocos3x/Sound';
    export { Ci18n as I18n } from 'tools-cocos3x/Ci18n';
    export { SpriteInfoBase } from 'tools-cocos3x/base/SpriteInfoBase';
    export { CI18nBase } from 'tools-cocos3x/base/CI18nBase';
}

declare module 'tools-cocos3x/CKeyUtil' {
    import { KeyCode } from 'cc';
    type keyName = keyof typeof KeyCode;
    /**
        * 按键监听工具，用于PC端，需要导入tools-javascript库
        */
    export class CKeyUtil {
            static keyMap: {
                    [key: number]: {
                            keyName: keyName;
                            keyCode: KeyCode;
                    };
            };
            /**
                * 管理器
                */
            static eventMap: any;
            /**
                * 注册全局按键事件
                */
            static init(): void;
            /**
                * 监听组合键
                * @param keys 组合键数组
                * @param callback 触发回调函数
                * @example
                * //Ctrl+Q
                * CKeyUtil.on(['Ctrl','Q'],()=>{
                *  console.log('成功')
                * })
                * @returns
                */
            static on(keys: keyName[], callback: Function): () => void;
    }
    export {};
}

declare module 'tools-cocos3x/Res' {
    import * as cc from 'cc';
    /**
        * 资源管理
        * @param i18n loadBundle支持国际化，如果配置了i18n，则只会加载对应语言的资源
        */
    export class Res {
            /**
                * 资源包
                */
            static bundleMap: {
                    [key: string]: cc.AssetManager.Bundle;
            };
            /**
                * 全局默认资源包名
                */
            static bundleName: string;
            /**
                * 获取资源
                * @param bundleName 资源包名
                * @param assetName 资源名
                * @returns 资源
                */
            static getAsset<T extends cc.Asset>(assetName: string, type: cc.__private._types_globals__Constructor<T>, bundleName?: string, lang?: string): Promise<T>;
            /** 是否支持国际化，默认开启，以当前语言作为Bundle的加载列表 */
            static i18n: boolean;
            /**
                * 加载单个资源包
                * @param bundleName 资源包名
                * @returns 资源包
                */
            static loadBundle(bundleName: string, config?: loadBundleParam): Promise<boolean>;
            /**
                * 加载资源包
                * @param bundleName 资源包名
                * @returns 资源包
                */
            static loadBundles(bundleNames: string[], config?: loadBundleParam): Promise<boolean>;
    }
    export type loadBundleParam = {
            /**
                * 单个加载进度回调
                * @param progress
                * @param total
                * @param totalTime
                * @returns
                */
            onProgress?: (param: loadBundleRes) => void;
            /**
                * 自定义资源加载列表
                * @param a 如果配置了该参数，则只会加载pathList中的资源，否则加载所有资源
                * @param a 比如：['prefab/main']只会加载prefab/main.prefab资源，而['prefab']则会加载prefab下的所有prefab资源
                */
            pathList?: string[];
            /**
                * 资源路径回调
                * @param dir 资源路径列表
                * @returns 返回新的资源路径列表
                */
            dirCallback?: (dir: cc.__private._cocos_asset_asset_manager_config__IAddressableInfo[]) => cc.__private._cocos_asset_asset_manager_config__IAddressableInfo[];
            /** 加载的语言 */
            lang?: string;
    };
    export type loadBundleRes = {
            /** 资源包 */
            bundle: cc.AssetManager.Bundle;
            /** 资源总数 */
            dir: cc.__private._cocos_asset_asset_manager_config__IAddressableInfo[];
            /** 加载时间 */
            totalTime: number;
            /** 资源包名 */
            bundleName: string;
            /** 加载进度 */
            progress: number;
            /** 资源信息 */
            info: cc.__private._cocos_asset_asset_manager_config__IAddressableInfo;
    };
}

declare module 'tools-cocos3x/Sound' {
    import { Node } from 'cc';
    import { SoundBean, SoundBeanParam } from 'tools-cocos3x/SoundBean';
    /**
        * 播放音频类
        */
    export class Sound {
            /**
                * 音频对象集合
                */
            static boundMap: {
                    [key: string]: SoundBean;
            };
            /**
                * 音频全局挂载接点
                */
            static rootNode: Node;
            /**
                * 全局默认音量大小
                */
            static volume: number;
            /**
                * 全局默认bundle下的音效路径
                */
            static dir: string;
            /**
                * 全局默认资源管理器
                */
            static Res: any;
            /**
                * 初始化
                * @param Res 资源管理器
                */
            static init(Res?: any): void;
            /**
                * 播放音频
                * @param musicName 音频名
                * @param param 参数
                * @returns 音频对象
                */
            static play(musicName: string, param?: Partial<SoundBeanParam & {
                    /**
                        * 是否自动播放-默认为true
                        */
                    autoPlay: boolean;
            }>): Promise<SoundBean>;
            /**
                * 获取参数-外部不使用
                * @param musicName 音频名
                * @param param 参数
                * @returns 参数
                */
            static getParam(musicName: string, param: Partial<SoundBeanParam>): {
                    musicName: string;
                    bundleName: any;
                    loop: boolean;
                    volume: number;
            } & Partial<SoundBeanParam>;
            /**
                * 获取音频对象-外部不使用，请使用play方法获取音频对象
                * @param musicName 音频名
                * @param param 参数
                * @returns 音频对象
                */
            static getSoundBean(musicName: string, param?: Partial<SoundBeanParam>): SoundBean;
            /**
                * 停止音频
                * @param musicName 音频名
                * @param param 参数
                */
            static stop(musicName: string, param?: Partial<SoundBeanParam>): void;
            /**
                * 暂停音频
                * @param musicName 音频名
                * @param param 参数
                */
            static pause(musicName: string, param?: Partial<SoundBeanParam>): void;
            /**
                * 恢复音频
                * @param musicName 音频名
                * @param param 参数
                */
            static resume(musicName: string, param?: Partial<SoundBeanParam>): void;
            /**
                * 销毁音乐资源对象
                * @param musicName 音频名
                * @param param 参数
                */
            static destroy(musicName: string, param?: Partial<SoundBeanParam>): void;
            /**
                * 整体调整所有音量大小
                * @param volume 音量大小
                */
            static setVolume(volume: number): void;
    }
}

declare module 'tools-cocos3x/Ci18n' {
    import * as cc from 'cc';
    /**
        * 国际化管理
        * @param label 文本：在label上写入的值对应json的key
        * @param plist 图片：对应语言的plist、png后缀如：_zh、_en等
        * @param audio 音频：对应语言的mp3后缀如：_zh、_en等
        * @param skeleton 骨骼动画：对应语言的json、atlas、png后缀如：_zh、_en等
        */
    export class Ci18n {
            /**
                * 语言json
                */
            static langJson: {
                    [key: string]: any;
            };
            /** 国际化节点 */
            static map: {
                    [key: string]: cc.Node;
            };
            /** 国际化节点原始数据 */
            static sourceMap: {
                    [key: string]: {
                            text: any;
                    };
            };
            /** 初始化国际化配置 */
            static init(config: {
                    /** 当前语言 */
                    lang: string;
                    /** 默认开发语言 */
                    defaultLang: string;
                    /** 除了默认语言外支持的语言列表 */
                    langList: string[];
            }): void;
            /** 注册国际化节点 */
            static on(node: cc.Node): string;
            /** 注销国际化节点 */
            static off(id: string): void;
            /** 注销所有国际化节点 */
            static clear(): void;
            /** 获取多语言文本配置，可自定义配置获取方式，默认使用http获取 */
            static getLangJson(lang: string): Promise<any>;
            /** 设置国际化节点 */
            static setNodeLang(node: cc.Node): Promise<void>;
            /** 默认开发语言-不带后缀 */
            static defaultLang: string;
            /** 当前语言 */
            static lang: string;
            /**
                * 支持的语言列表
                */
            static langList: string[];
            /** 资源数据备份 */
            static resMap: {
                    [key: string]: any;
            };
            /** 资源数据路径列表 */
            static resListPath: string[];
            /** 由Res调用加载资源映射 */
            static loadResMap(key: string): void;
            /** 设置语言 */
            static setLang(lang: string): Promise<void>;
            /** 判断路径是否包含语言后缀 */
            static pathInList(path: string): {
                    status: boolean;
                    index: number;
            };
    }
}

declare module 'tools-cocos3x/base/SpriteInfoBase' {
    import * as cc from 'cc';
    /**
      * 节点使用配置，对图片和骨骼进行多语言处理
      */
    export class SpriteInfoBase extends cc.Component {
        /** 骨骼动画默认播放动画名称 */
        aniName: string;
        /** 骨骼动画默认播放动画是否循环 */
        aniLoop: boolean;
        /** 资源路径 */
        url: string;
        /** 资源UUID */
        urlUUID: string;
        /** 资源名称 */
        urlName: string;
        /** 资源类型 */
        type: string;
        onLoad(): Promise<void>;
        /** 骨骼组件 */
        skeleton: cc.sp.Skeleton;
        /** 精灵组件 */
        sprite: cc.Sprite;
        /** 加载节点内容Promise */
        loadNodePro: Promise<any>;
        /** 是否第一次加载骨骼动画 */
        aniFirstLoad: boolean;
        /** 加载节点内容 */
        loadNode(): Promise<any>;
        onDisable(): void;
        onDestroy(): void;
    }
}

declare module 'tools-cocos3x/base/CI18nBase' {
    import * as cc from 'cc';
    /**
      * 在顶级节点使用，注册多语言节点
      */
    export class CI18nBase extends cc.Component {
        static editor: {
            /** 监听时间 */
            time: number;
            /** 监听定时器 */
            timer: any;
            /** 监听节点 */
            map: {
                [key: string]: cc.Node;
            };
            setCom: (child: cc.Node, sprite: any, spriteDataField: string) => void;
            updateNodeLang: (child: cc.Node) => Promise<void>;
            /** 监听编辑器内资源变化 */
            on: (node: cc.Node, _id: string) => void;
            /** 取消监听编辑器内资源变化 */
            off: (id: string) => void;
        };
        id: string;
        onLoad(): void;
        onDestroy(): void;
    }
}

declare module 'tools-cocos3x/SoundBean' {
    import { AudioClip, AudioSource, Node } from 'cc';
    export class SoundBean {
            node: Node;
            audioSource: AudioSource;
            id: string;
            param: SoundBeanParam;
            /**
                * 设置配置
                * @param param 参数
                */
            setConfig(param: SoundBeanParam): Promise<void>;
            /**
                * 播放开始回调
                */
            onAudioStarted(): void;
            /**
                * 播放结束回调
                */
            onAudioEnded(): void;
            /**
                * 播放音频
                */
            play(): void;
            /**
                * 停止音频
                */
            stop(): void;
            /**
                * 暂停音频
                */
            pause(): void;
            /**
                * 恢复音频
                */
            resume(): void;
            /**
                * 设置音频资源
                * @param clip 音频
                */
            setClip(clip: AudioClip): void;
            /**
                * 设置音量
                * @param volume 音量
                */
            setVolume(volume: number): void;
            /**
                * 销毁音频
                */
            destroy(): void;
    }
    export type SoundBeanParam = {
            /**
                * 资源包名
                */
            bundleName: string;
            /**
                * 音乐地址
                */
            musicName: string;
            /**
                * 是否循环播放
                */
            loop: boolean;
            /**
                * 是否自动播放
                */
            autoPlay: boolean;
            /**
                * 音量
                */
            volume: number;
            /**
                * 播放开始回调
                */
            startFun: Function;
            /**
                * 播放结束回调
                */
            endFun: Function;
            /**
                * 资源路径
                */
            dir: string;
            /**
                * 资源管理器
                */
            Res: any;
    };
}

